//+------------------------------------------------------------------+
//|                                                  EMA Crosses.mq4 |
//|                                           Copyright Hafeez 2008 |
//|                                            http://www.hafeez.com |
//+------------------------------------------------------------------+
#property copyright "Copyright Hafeez 2008"
#property link      "http://www.hafeez.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//---- indicator parameters
extern int EMA_Period1 = 9;

extern int EMA_Period2 = 5;
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double pr=2.0/(EMA_Period1+1);
   int    pos=Bars-2;
   if(ExtCountedBars>2) pos=Bars-ExtCountedBars-1;

//---- main calculation loop
   while(pos>=0)
     {
      if(pos==Bars-2) ExtMapBuffer1[pos+1]=Close[pos+1];
      ExtMapBuffer1[pos]=Close[pos]*pr+ExtMapBuffer1[pos+1]*(1-pr);
 	   pos--;
     }
  }
//----
   return(0);
//+------------------------------------------------------------------+